#property copyright "Svinozavr"
#property indicator_chart_window //   
#property indicator_buffers 6
#property indicator_color1 Green
#property indicator_color2 Red  
#property indicator_color3 Green
#property indicator_color4 Red  
#property indicator_color5 Green
#property indicator_color6 Red  

//  
extern string TimeFrame   = "Current time frame";
extern double MAperiod     = 200; 
extern double K            = 1.3;   //    ( )
extern double Bord         = 0;     // 
              
extern bool   Fade         = true; //  
extern bool   OC.HL.range  = true; //   
extern bool   OC.HL.middle = true; //    
extern bool   Hist         = true;

//     
double Top[],Bot[],Sup[],Res[]; 
double up[],dn[];
//   
double k0,k1,period; // . EMA   
double brd; 
int    History=0; // 0-  
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

// 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() 
{ 
  brd=Bord*Point;
  if(MAperiod>1)
  {
    k0=2/(1+MAperiod); 
    period=MAperiod;
  }
  else 
  { 
    k0=MAperiod; 
    period=(2-MAperiod)/MAperiod;
  }
  k1=1-k0;
   
  if(Hist) 
  {
    int stl=3,sw=1;
  } 
  else 
  {
    stl=0;sw=2;
  }
  SetIndexBuffer(0,Top); // 
  SetIndexStyle(0,DRAW_LINE);

  SetIndexBuffer(1,Bot); //  
  SetIndexStyle(1,DRAW_LINE);

  SetIndexBuffer(2,Sup); //  
  SetIndexStyle(2,stl,0,sw);
  SetIndexArrow(2,117);

  SetIndexBuffer(3,Res); //  
  SetIndexStyle(3,stl,0,sw);
  SetIndexArrow(3,117);
  
  SetIndexBuffer(4,up); //  
  SetIndexStyle(4,stl,0,sw+1);
  SetIndexArrow(4,117);
  
  SetIndexBuffer(5,dn); //  
  SetIndexStyle(5,stl,0,sw+1);
  SetIndexArrow(5,117);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
  
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() 
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if(History!=0 && limit>History) 
                limit=History-1; // -   
           if (returnBars) { Top[0] = limit+1; return(0); }

  //  
   if (calculateValue || timeFrame == Period())
   {
  for(int i=limit; i>=0; i--) 
  { 
    //  
    if(OC.HL.middle)
    {
      double mid=(High[i]+Low[i])/2;
    }  
    else 
    {
      mid=(Close[i]+Open[i])/2;
    }  
    
    // 
    if(OC.HL.range) 
    {
      double rng=High[i]-Low[i];
    }  
    else 
    {
      rng=MathAbs(Close[i]-Open[i]);
    }  
    
    // EMA
    static double dt,db;
    double ma0; 
    static double ma1;
    if(i==limit && i>1) 
    {
      ma0=rng; //  
      dt=0;db=0;
    }
    else 
    { //  
      if(rng>ma1 && Fade) 
      {
        ma0=rng;
      }  
      else 
      {
        ma0=k0*rng+k1*ma1;
      }  
    }
    if(i>0) 
    {
      ma1=ma0;
    }  
    
    // 
    double diff=K*ma0;
    Top[i]=mid+diff;
    Bot[i]=mid-diff;
    
    // 
    static bool trend;
    if(i>0) 
    {
      double difft=Close[i]-Top[i];
      double diffb=Close[i]-Bot[i];
      if(difft>0) 
      {
        trend=1; 
        dt=difft;
        if(Hist) 
        {
          Sup[i]=(Close[i]+Open[i])/2;
          if(difft>=-db+brd) 
          {
            up[i]=Top[i];
          }  
        }
      }
      if(diffb<0) 
      {
        trend=0; 
        db=diffb;
        if(Hist) 
        {
          Res[i]=(Close[i]+Open[i])/2;
          if(diffb<=-dt-brd) 
          {
            dn[i]=Bot[i];
          }  
        }
      }
    }
    if(!Hist && i>0) 
    {
      if(trend) 
      {
        Sup[i]=Bot[i];
      }   
      else 
      {
        Res[i]=Top[i];
      }  
    }
//  Sup[i]=Sup[i+1]; Res[i]=Res[i+1];
  }
  return(0);
   }  
  
  //
  //
  //
  //
  //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);               
          Top[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAperiod,K,Bord,Fade,OC.HL.range,OC.HL.middle,Hist,0,y);
          Bot[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAperiod,K,Bord,Fade,OC.HL.range,OC.HL.middle,Hist,1,y);
          Sup[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAperiod,K,Bord,Fade,OC.HL.range,OC.HL.middle,Hist,2,y);
          Res[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAperiod,K,Bord,Fade,OC.HL.range,OC.HL.middle,Hist,3,y);
          up[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAperiod,K,Bord,Fade,OC.HL.range,OC.HL.middle,Hist,4,y);
          dn[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MAperiod,K,Bord,Fade,OC.HL.range,OC.HL.middle,Hist,5,y);
   }          
   return(0);
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


